

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>How to set up ‘hourly’ logging with pywws &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="User guides" href="index.html" />
    <link rel="next" title="How to set up ‘live’ logging with pywws" href="livelogging.html" />
    <link rel="prev" title="How to get started with pywws" href="getstarted.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="livelogging.html" title="How to set up ‘live’ logging with pywws"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="getstarted.html" title="How to get started with pywws"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">User guides</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="how-to-set-up-hourly-logging-with-pywws">
<h1>How to set up &#8216;hourly&#8217; logging with pywws<a class="headerlink" href="#how-to-set-up-hourly-logging-with-pywws" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>There are two quite different modes of operation with pywws. Traditionally the <a class="reference internal" href="../api/Hourly.html"><em>Hourly</em></a> program would be run at regular intervals (usually an hour) from cron. This is suitable for fairly static websites, but more frequent updates can be useful for sites such as Weather Underground (<a class="reference external" href="http://www.wunderground.com/">http://www.wunderground.com/</a>). The newer <a class="reference internal" href="../api/LiveLog.html"><em>LiveLog</em></a> program runs continuously and can upload data every 48 seconds.</p>
<p>Note that although this document (and the program name) refers to &#8216;hourly&#8217; logging, you can run the Hourly.py program as often or as infrequently as you like, but don&#8217;t try to run it more often than half your logging frequency. For example, if your logging interval is 10 minutes, don&#8217;t run Hourly.py more often than every 20 minutes.</p>
</div>
<div class="section" id="getting-started">
<h2>Getting started<a class="headerlink" href="#getting-started" title="Permalink to this headline">¶</a></h2>
<p>First of all, you need to install pywws and make sure it can get data from your weather station. See <a class="reference internal" href="getstarted.html"><em>How to get started with pywws</em></a> for details.</p>
<p>Try running Hourly.py from the command line, with a high level of verbosity so you can see what&#8217;s happening:</p>
<div class="highlight-python"><pre>python Hourly.py -vvv ~/weather/data</pre>
</div>
<p>Within five minutes (assuming you have set a 5 minute logging interval) you should see a &#8216;live_data new ptr&#8217; message, followed by fetching any new data from the weather station and processing it.</p>
</div>
<div class="section" id="configuring-file-locations">
<h2>Configuring file locations<a class="headerlink" href="#configuring-file-locations" title="Permalink to this headline">¶</a></h2>
<p>Open your weather.ini file with a text editor. You should have a <tt class="docutils literal"><span class="pre">[paths]</span></tt> section similar to the following (where <tt class="docutils literal"><span class="pre">xxx</span></tt> is your user name):</p>
<div class="highlight-python"><pre>[paths]
work = /tmp/weather
templates = /home/xxx/weather/templates/
graph_templates = /home/xxx/weather/graph_templates/</pre>
</div>
<p>Edit these to suit your installation and preferences. <tt class="docutils literal"><span class="pre">work</span></tt> is a temporary directory used to store intermediate files, <tt class="docutils literal"><span class="pre">templates</span></tt> is the directory where you keep your text template files and <tt class="docutils literal"><span class="pre">graph_templates</span></tt> is the directory where you keep your graph template files. Don&#8217;t use the pywws example directories for these, as they will get over-written when you upgrade pywws.</p>
<p>Copy your text and graph templates to the appropriate directories. You may find some of the examples provided with pywws useful to get started.</p>
</div>
<div class="section" id="configuring-periodic-tasks">
<h2>Configuring periodic tasks<a class="headerlink" href="#configuring-periodic-tasks" title="Permalink to this headline">¶</a></h2>
<p>In weather.ini you should have <tt class="docutils literal"><span class="pre">[logged]</span></tt>, <tt class="docutils literal"><span class="pre">[hourly]</span></tt>, <tt class="docutils literal"><span class="pre">[12</span> <span class="pre">hourly]</span></tt> and <tt class="docutils literal"><span class="pre">[daily]</span></tt> sections similar to the following:</p>
<div class="highlight-python"><div class="highlight"><pre><span class="p">[</span><span class="n">logged</span><span class="p">]</span>
<span class="n">services</span> <span class="o">=</span> <span class="p">[]</span>
<span class="n">twitter</span> <span class="o">=</span> <span class="p">[]</span>
<span class="n">plot</span> <span class="o">=</span> <span class="p">[]</span>
<span class="n">text</span> <span class="o">=</span> <span class="p">[]</span>

<span class="p">[</span><span class="n">hourly</span><span class="p">]</span>
<span class="o">...</span>
</pre></div>
</div>
<p>These specify what Hourly.py should do when it is run. Tasks in the <tt class="docutils literal"><span class="pre">[logged]</span></tt> section are done every time there is new logged data, tasks in the <tt class="docutils literal"><span class="pre">[hourly]</span></tt> section are done every hour, tasks in the <tt class="docutils literal"><span class="pre">[12</span> <span class="pre">hourly]</span></tt> section are done twice daily and tasks in the <tt class="docutils literal"><span class="pre">[daily]</span></tt> section are done once per day.</p>
<p>The <tt class="docutils literal"><span class="pre">services</span></tt> entry is a list of online weather services to upload data to. The <tt class="docutils literal"><span class="pre">plot</span></tt> and <tt class="docutils literal"><span class="pre">text</span></tt> entries are lists of template files for plots and text files to be uploaded to your web site, and the <tt class="docutils literal"><span class="pre">twitter</span></tt> entry is a list of templates for messages to be posted to Twitter. Add the names of your template files and weather services to the appropriate entries, for example:</p>
<div class="highlight-python"><pre>[logged]
services = ['underground', 'metoffice']
twitter = []
plot = []
text = []

[hourly]
services = []
twitter = ['tweet.txt']
plot = ['7days.png.xml', '24hrs.png.xml', 'rose_24hrs.png.xml']
text = ['24hrs.txt', '6hrs.txt', '7days.txt']

[12 hourly]
services = []
twitter = []
plot = []
text = []

[daily]
services = []
twitter = ['forecast.txt']
plot = ['28days.png.xml']
text = ['allmonths.txt']</pre>
</div>
<p>You can test that all these are working by removing all <tt class="docutils literal"><span class="pre">last</span> <span class="pre">update</span></tt> lines from weather.ini then run Hourly.py again:</p>
<div class="highlight-python"><pre>python Hourly.py -v ~/weather/data</pre>
</div>
</div>
<div class="section" id="run-as-a-cron-job">
<h2>Run as a cron job<a class="headerlink" href="#run-as-a-cron-job" title="Permalink to this headline">¶</a></h2>
<p>Most UNIX/Linux systems have a &#8216;cron&#8217; daemon that can run programs at certain times, even if you are not logged in to the computer. You edit a &#8216;crontab&#8217; file to specify what to run and when to run  it. For example, to run Hourly.py every hour, at zero minutes past the hour:</p>
<div class="highlight-python"><pre>0 * * * *       python /home/jim/pywws/Hourly.py /home/jim/weather/data</pre>
</div>
<p>This might work, but if it didn&#8217;t you probably won&#8217;t get any error messages to tell you what went wrong. It&#8217;s much better to run a script that runs Hourly.py and then emails you any output it produces. Here&#8217;s the script I use:</p>
<div class="highlight-python"><pre>#!/bin/sh
#
# weather station logger calling script

if [ ! -d /data/weather/ ]; then
  exit
  fi

log=/var/log/log-weather

cd /home/jim/weather/devel
python ./Hourly.py -v /data/weather &gt;$log 2&gt;&amp;1

# mail the log file
/home/jim/scripts/email-log.sh $log "weather log"</pre>
</div>
<p>You’ll need to edit this quite a lot to suit your file locations and so on, but it gives some idea of what to do.</p>
<p>Comments or questions? Please subscribe to the pywws mailing list <a class="reference external" href="http://groups.google.com/group/pywws">http://groups.google.com/group/pywws</a> and let us know.</p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">How to set up &#8216;hourly&#8217; logging with pywws</a><ul>
<li><a class="reference internal" href="#introduction">Introduction</a></li>
<li><a class="reference internal" href="#getting-started">Getting started</a></li>
<li><a class="reference internal" href="#configuring-file-locations">Configuring file locations</a></li>
<li><a class="reference internal" href="#configuring-periodic-tasks">Configuring periodic tasks</a></li>
<li><a class="reference internal" href="#run-as-a-cron-job">Run as a cron job</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="getstarted.html"
                        title="previous chapter">How to get started with pywws</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="livelogging.html"
                        title="next chapter">How to set up &#8216;live&#8217; logging with pywws</a></p>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="livelogging.html" title="How to set up ‘live’ logging with pywws"
             >next</a> |</li>
        <li class="right" >
          <a href="getstarted.html" title="How to get started with pywws"
             >previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >User guides</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>